# [drslib - a set of utilities by DavidRodriguezSoaresCUI](https://github.com/DavidRodriguezSoaresCUI/DRSlib)

drslib is a Python package that provides a wide range of small
yet powerful and highly-reusable functions, classes,
decorators, etc. Its main purpose is to provide high-level
"building blocks" that accomplish simple tasks, facilitating
the writing of elaborate scripts with limited code.

License: see LICENSE file.

Author: DavidRodriguezSoaresCUI

## Installation

From a terminal execute:

```bash
python -m pip install drs.drslib
```

> Note that on some systems it may be necessary to specify python version as `python3` or `python3.10`

### Installation from source

Download/``git clone`` the project, open it in a terminal end execute ``python -m pip install .``

### Install optional dependencies

To install dependencies required for building documentation : ``python -m pip install .[doc]`` (or if you use `flit` : ``flit install --deps=doc``)

To install dependencies required for:

- building documentation : ``python -m pip install .[doc]`` (or if you use `flit` : ``flit install --deps=doc``)

- code analysis : ``python -m pip install .[analyse]`` (or if you use `flit` : ``flit install --deps=analyse``)

- running tests : ``python -m pip install .[test]`` (or if you use `flit` : ``flit install --deps=test``)

## Run tests

First some requirements (step 3 needs to be re-run if you make changes) :

1. Download/``git clone`` the project and open it in a terminal
2. Install the testing requirements with ``python -m pip install .[test]``
3. Install the project with ``python -m pip install -e .``
   > It needs to be installed in editable mode for coverage to work

Then you can simply run ``pytest`` (from a terminal at the downloaded project directory)

## Documentation

You can find documentation in source code docstrings, or, more practically, by building
documentation from source. After you have installed optional documentation building dependencies :

- On `Windows`: Run `sphinx-full-rebuild.bat` from directory `docs`
- On `Linux`: If your shell is bash compatible, run `sphinx-full-rebuild.sh` from directory `docs`. If not, you should be capable of adapting it to your system.

## Warning to users

**drslib** is a quickly evolving package, and author doesn't take any responsibility to maintain it or to keep
its API stable, but will make a good faith effort to do so. Also, some of its code writes to the disk, so its use
may lead to data loss.

Use it at your own risk.

This project structure was generated by [python-project-quickstart](https://github.com/DavidRodriguezSoaresCUI/python-project-quickstart)
